##############################################################################
# REPLACE STRINGS
#
# USED NAMES:
# samplename (TGZ-Build)	= PkgName
# sampledir (ksm-tgzbuild)	= pkg-dirname = pkg-filename (ksm-xxx)
# sampleconf (sampleconf)	= config file name (no extension)
# sampledm (sampledm)		= the daemon (rc-script, rc-link, systemd.service)
# sample (sample)		= all others
##############################################################################

# Specfile for TGZ-Build

%define name		ksm-tgzbuild
%define version		0.0.3
%define release		10.0.0
%define _arch		noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _bindir		/usr/local/bin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}

Summary:	program to build TGZ Archives
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		Productivity/Other
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	ksm-tgzbuildpkg,ksm-tgzbuildcapab
Requires:	ksm-lib-sh >= 5.0.1-0.0.0,ksm-textproc >= 1.0.1-11.0.0
#Provides:	ksm-tgzbuildd
#Conflicts:	ksm-tgzbuildd-other,libksm-tgzbuild == 0.0.0
#Obsoletes:	myksm-tgzbuildd

%description
This package contains the following programs:

 make-reflist	Build reference lists from a shell script or a Tcl/Tk prog.
 tgzbuild	Manage a TGZ Archive.

Please check/configure:
 /usr/local/etc/tgzbuild.conf

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/tgzbuild.conf
#%config %{_confdir}/tgzbuild.conf
#%config %{_scnfdir}/tgzbuild
%{_confdir}/tgzbuild.conf

#%attr(744,root,root)/%{_rcdir}/tgzbuildd
#%attr(777,root,root)%{_bindir}/rctgzbuildd

%attr(755,root,root)%{_bindir}/make-reflist
%attr(744,root,root)%{_bindir}/tgzbuild

%{_datadir}/RELEASE
%{_datadir}/VERSION
%{_datadir}/install.sh.templ
%{_datadir}/pkg.dat.templ

#/usr/share/applications/tgzbuild.desktop
#%{_icondir}/16x16/apps/tgzbuild.png
#%{_icondir}/22x22/apps/tgzbuild.png
#%{_icondir}/32x32/apps/tgzbuild.png
#%{_icondir}/48x48/apps/tgzbuild.png
#%{_icondir}/64x64/apps/tgzbuild.png
#%{_icondir}/128x128/apps/tgzbuild.png
#/usr/share/pixmaps/tgzbuild.png

%docdir %{_man1dir}
%{_man1dir}/make-reflist.1.gz

%docdir %{_man8dir}
%{_man8dir}/tgzbuild.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
#%{_docdir}/README.de

#---------------------- ORDER OF SCRIPTLETS ----------------------------------
# O=old pkg, N=new pkg

# INSTALL:
# 1. Run %pre section of N		(Arg is 1)
# 2. Install files from N
# 3. Run %post section of N		(Arg is 1)

# UNINSTALL:
# 1. Run %preun section of O		(Arg is 0)
# 2. Delete files from O
# 3. Run %postun section of O		(Arg is 0)

# UPGRADE:
#  1. Run %pre section of O		(Arg is 2)
#  2. Install files from N
#  3. Run %post section of N		(Arg is 2)
#  4. Execute install. triggers (%triggerin in other pkgs) set off by install N
#  5. Execute installation triggers of N
#  6. Execute uninstallation triggers (%triggerun) of O
#  7. Execute uninstallation triggers (of other pkgs) set off by uninstall O
#  8. Run %preun section of O		(Arg is 1)
#  9. Delete files from O not contained in N
# 10. Run %postun section of O		(Arg is 1)

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# backup config files
test -e %{_confdir}/tgzbuild.conf && cp %{_confdir}/tgzbuild.conf %{_confdir}/tgzbuild.conf.rpmsave
#test -e %{_scnfdir}/tgzbuild && cp %{_scnfdir}/tgzbuild %{_scnfdir}/tgzbuild.rpmsave

# disable sample and stop sampledm
#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -d -q > /dev/null 2>&1
#test -x %{_rcdir}/sampledm && %{_rcdir}/sampledm stop > /dev/null 2>&1

# remove links
#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog

# uninstall desktop files
#xdg-desktop-menu uninstall \
#	/usr/share/applications/tgzbuild.directory \
#	/usr/share/applications/tgzbuild.desktop \
#	/usr/share/applications/tgzbuild-admin.desktop

#if [ "$1" == 1 ]; then					# install package
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# set config pathname. config file needs a version at first cnfvar!
cf=%{_confdir}/tgzbuild.conf
cnfvars=$(grep -v '^#' $cf | grep '[[:alnum:]]' | grep -v '\[' | cut -sd '=' -f1)
cnfvars=$(echo $cnfvars | cut -d ' ' -f2-)
ret=0

# set links
#ln -sf /usr/bin/prog %{_bindir}/myprog

# install desktop files
#xdg-desktop-menu install --novendor \
#	/usr/share/applications/tgzbuild.directory \
#	/usr/share/applications/tgzbuild.desktop \
#	/usr/share/applications/tgzbuild-admin.desktop

if [ "$1" == 1 ]; then					# install package
	echo "Configure $cf"
#	echo "Users must create HOME/.tgzbuildrc with update-tgzbuild"
else							# upgrade package
	# update global conf
	if [ -e $cf.rpmsave ]; then
		c='' s='' t=''
		#cp $cf $cf.rpmnew
		. $cf
		. $cf.rpmsave
		if [ -x %{_bindir}/replcnfvar ]; then
			for c in $cnfvars; do
				t="\$$c"
				eval s="$t"
				s=\"$s\"
				%{_bindir}/replcnfvar $cf $c "$s"
			done
		else
			echo "Error - cmd replcnfvar not found or not executable!" >&2
			echo "Conf file not updated!" >&2
		fi

#		# update array vars MainArr HelpArr
#		cnt=0 i=0
#		cnt=${#MainArr[@]}			# max index of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any arrays in use?
#			while [ "$i" -lt $cnt ]; do
#				let i++
#				# array MainArr
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#				# array HelpArr
#				s="HelpArr[$i]=\"${HelpArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#			done
#		fi

		diff $cf $cf.rpmsave > /dev/null 2>&1
		ret=$?
		if [ "$ret" -eq 0 ]; then
			rm $cf.rpmsave
		else
			echo "Check $cf"
		fi
	fi

#	echo "If new version then users must update HOME/.tgzbuildrc with update-tgzbuild"
fi
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	# backup config files
	test -e %{_confdir}/tgzbuild.conf && cp %{_confdir}/tgzbuild.conf %{_confdir}/tgzbuild.conf.rpmsave
	#test -e %{_scnfdir}/tgzbuild && cp %{_scnfdir}/tgzbuild %{_scnfdir}/tgzbuild.rpmsave

	# disable tgzbuild and stop tgzbuildd
	#test -x %{_bindir}/toggletgzbuild && %{_bindir}/toggletgzbuild -d -q > /dev/null 2>&1
	#test -x %{_rcdir}/tgzbuildd && %{_rcdir}/tgzbuildd stop > /dev/null 2>&1

	# remove links
	#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog

	# uninstall desktop files
	#xdg-desktop-menu uninstall \
	#	/usr/share/applications/tgzbuild.directory \
	#	/usr/share/applications/tgzbuild.desktop \
	#	/usr/share/applications/tgzbuild-admin.desktop
#else							# upgrade package
fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/tgzbuild

#else							# upgrade package
fi
exit 0

%changelog
* Thu May 11 2023 Repomaster <repomaster@kaesmann-online.de> 0.0.3-10.0.0
- 'make-reflist' has been revised/improved
- The installscript has been revised/improved

* Tue May 09 2023 Repomaster <repomaster@kaesmann-online.de> 0.0.3-9.0.0
- The installscript has been revised/improved

* Mon Mar 14 2022 Repomaster <repomaster@kaesmann-online.de> 0.0.3-8.1.0
- Following progs have been revised/improved:
  make-reflist, tgzbuild.

* Mon Mar 07 2022 Repomaster <repomaster@kaesmann-online.de> 0.0.3-8.0.0
- All progs have been revised/improved.

* Fri Feb 18 2022 Repomaster <repomaster@kaesmann-online.de> 0.0.3-7.0.0
- Following progs have been revised/improved:
  make-reflist, tgzbuild.

* Thu Jan 06 2022 Repomaster <repomaster@kaesmann-online.de> 0.0.3-6.0.0
- Update to the libfuncstd-sh 4.0.0

* Mon May 04 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.3-5.8.0
- make-reflist has been revised/improved.

* Sat Apr 25 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.3-5.7.0
- make-reflist has been revised/improved
  (option -l has been modified).

* Wed Apr 22 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.3-5.6.0
- make-reflist has been revised/improved.

* Mon Mar 30 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.3-5.5.0
- make-reflist has been revised.

* Sun Mar 29 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.3-5.4.0
- make-reflist has been revised.

* Sat Mar 07 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.3-5.3.0
- make-reflist has been revised.

* Sun Feb 23 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.3-5.2.0
- make-reflist has been revised.

* Sat Feb 22 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.3-5.1.0
- make-reflist has been revised.

* Fri Feb 21 2020 Repomaster <repomaster@kaesmann-online.de> 0.0.3-5.0.0
- make-reflist has been revised.

* Thu Nov 16 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.3-4.0.0
- 'make-reflist' has been revised.

* Wed Nov 08 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.3-3.0.0
- 'make-reflist' has been revised
  (function names must be words now).

* Tue Nov 07 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.3-2.0.0
- 'make-reflist' has been revised.

* Sat Nov 04 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.3-1.0.0
- Added 'make-reflist'.
- 'make-functionlist' and 'make-proclist' have been removed.

* Wed Nov 01 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.3-0.1.0
- The package has been revised.

* Fri May 05 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.3-0.0.0
- The package has been revised
  (removed 'update-tgzbuild',
   changed from local config to global config).

* Wed Apr 26 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.2-0.2.0
- tgzbuild has been revised
  (using it without any argument).

* Fri Mar 10 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.2-0.1.0
- make-functionlist and make-proclist
  have been revised (added cmd -s).

* Thu Feb 09 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.2-0.0.0
- Instead of a global conf we use a user
  specific rc file.

* Wed Feb 08 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.1-1.0.0
- Added the scripts make-functionlist
  and make-proclist

* Tue Feb 07 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.4.0
- All scripts have been revised
  (using function GetOpt).

* Fri Jan 13 2017 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.3.0
- All scripts have been revised.

* Tue Nov 08 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.2.0
- The script tgzbuild has been revised.

* Wed Nov 02 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.1.0
- The script install.sh.templ has been revised.

* Sun Mar 20 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.1-0.0.0
- The package has been revised.

* Sun Mar 20 2016 Repomaster <repomaster@kaesmann-online.de> 0.0.0-0.0.0
- The script tgzbuild has been moved from package 
  ksm-root-admin to this package.
- The package contains following programs:
  tgzbuild:	Build tarballs
